(function ($) {
  var wind_ = $(window),
      body_ = $('body');
  feather.replace();
  flexTable(); // Active pages, automatically show on the menu

  $('.navigation .navigation-menu-body ul li a.active').closest('ul').parent('li').addClass('open').closest('ul').parent('li').addClass('open');
  $('[data-background-image]').each(function (e) {
    $(this).css("background", 'url(' + $(this).data('background-image') + ')');
  });
  var table_responsive_stack = $(".table-responsive-stack");
  table_responsive_stack.find("th").each(function (i) {
    $(".table-responsive-stack td:nth-child(" + (i + 1) + ")").prepend('<span class="table-responsive-stack-thead">' + $(this).text() + ":</span> ");
    $(".table-responsive-stack-thead").hide();
  });
  table_responsive_stack.each(function () {
    var thCount = $(this).find("th").length,
        rowGrow = 100 / thCount + "%";
    $(this).find("th, td").css("flex-basis", rowGrow);
  }); //------------------- Methods -------------------

  $.createOverlay = function () {
    if ($('.overlay').length < 1) {
      body_.addClass('no-scroll').append('<div class="overlay"></div>');
      $('.overlay').addClass('show');
    }
  };

  $.removeOverlay = function () {
    body_.removeClass('no-scroll');
    $('.overlay').remove();
  };

  function flexTable() {
    if (wind_.width() < 768) {
      $(".table-responsive-stack").each(function (i) {
        $(this).find(".table-responsive-stack-thead").show();
        $(this).find("thead").hide();
      }); // window is less than 768px
    } else {
      $(".table-responsive-stack").each(function (i) {
        $(this).find(".table-responsive-stack-thead").hide();
        $(this).find("thead").show();
      });
    }
  } //------------------- Events -------------------


  window.onresize = function () {
    flexTable();
  };

  $(document).on('click', '[data-toggle="fullscreen"]', function () {
    $(this).toggleClass('active-fullscreen');

    if (document.fullscreenEnabled) {
      if ($(this).hasClass("active-fullscreen")) {
        document.documentElement.requestFullscreen();
      } else {
        document.exitFullscreen();
      }
    } else {
      alert("Your browser does not support fullscreen.");
    }

    return false;
  });
  $(document).on('click', '.overlay', function () {
    $.removeOverlay();
    $('.navigation').removeClass('open');
  });
  $(document).on('click', '[data-sidebar-target]', function () {
    var target = $(this).data('sidebar-target');
    $('body').addClass('no-scroll');
    $('.sidebar-group').addClass('show');
    $('.sidebar-group .sidebar').removeClass('show');
    $('.sidebar-group .sidebar' + target).addClass('show');

    if ($('.sidebar-group').hasClass('show')) {
      $('.sidebar-group .sidebar' + target).niceScroll();
    } else {
      $('.sidebar-group .sidebar' + target).getNiceScroll().remove();
    }

    return false;
  });
  $(document).on('click', '.sidebar-group', function (e) {
    if ($(e.target).is($('.sidebar-group'))) {
      $('.sidebar-group').removeClass('show');
      $('body').removeClass('no-scroll');
      $('.sidebar-group .sidebar').removeClass('show');
      $('.sidebar-group .sidebar').getNiceScroll().remove();
    }
  });
  setTimeout(function () {
    $('.preloader').fadeOut(300);
  },1000);
  wind_.on('load', function () {
    setTimeout(function () {
      $('.navigation .navigation-menu-body ul li a').each(function () {
        var $this = $(this);

        if ($this.next('ul').length) {
          $this.append('<i class="sub-menu-arrow ti-angle-up"></i>');
        }
      });
      $('.navigation .navigation-menu-body ul li.open>a>.sub-menu-arrow').removeClass('ti-plus').addClass('ti-minus').addClass('rotate-in');
      $('body.horizontal-navigation .horizontal-navigation ul li a').each(function () {
        var $this = $(this);

        if ($this.next('ul').length) {
          $this.append('<i class="sub-menu-arrow ti-angle-right"></i>');
        }
      });
    }, 200);
  });
  $(document).on('click', '.navigation-toggler a', function () {
    $.createOverlay();
    $('.navigation').toggleClass('open');
    return false;
  });
  $(document).on('click', '.header-toggler a', function () {
    $('.header .header-body').toggleClass('open');
    return false;
  });
  $(document).on('click', '*', function (e) {
    if (!$(e.target).is($('.navigation, .navigation *, .navigation-toggler *')) && body_.hasClass('navigation-toggle-one')) {
      body_.removeClass('navigation-show');
    }
  });
  $(document).on('click', '*', function (e) {
    if (!$(e.target).is('.header ul.navbar-nav, .header ul.navbar-nav *, .header-toggler, .header-toggler *')) {
      $('.header .header-body').removeClass('open');
    }
  });
  /*------------- responsive html table -------------*/

  /*------------- Header search -------------*/

  $(document).on('click', '[data-toggle="search"], [data-toggle="search"] *', function () {
    $('.header .header-body .header-search').show().find('.form-control').focus();
    return false;
  });
  $(document).on('click', '.close-header-search, .close-header-search svg', function () {
    $('.header .header-body .header-search').hide();
    return false;
  });
  $(document).on('click', '*', function (e) {
    if (!$(e.target).is($('.header, .header *, [data-toggle="search"], [data-toggle="search"] *'))) {
      $('.header .header-body .header-search').hide();
    }
  });
  /*------------- Navigation collapse -------------*/

  $(document).on('click', '.navigation ul li a', function () {
    var $this = $(this);

    if ($this.next('ul').length) {
      if (!body_.hasClass('horizontal-navigation') || wind_.width() < 1200) {
        var sub_menu_arrow = $this.find('.sub-menu-arrow');
        sub_menu_arrow.toggleClass('rotate-in');
        $this.next('ul').toggle(250);
        $this.parent('li').siblings().not($this.parent('li')).find('ul').hide(250);
        $this.next('ul').find('li>ul').hide('open');
        $this.next('ul').find('li>a').find('.sub-menu-arrow').removeClass('ti-minus').addClass('ti-plus');
        $this.next('ul').find('li>a').find('.sub-menu-arrow').removeClass('rotate-in');
        $this.parent('li').siblings().not($this.parent('li').find('ul')).find('>a').find('.sub-menu-arrow').removeClass('ti-minus').addClass('ti-plus');
        $this.parent('li').siblings().not($this.parent('li').find('ul')).find('>a').find('.sub-menu-arrow').removeClass('rotate-in');

        if (sub_menu_arrow.hasClass('rotate-in')) {
          setTimeout(function () {
            sub_menu_arrow.removeClass('ti-plus').addClass('ti-minus');
          }, 200);
        } else {
          sub_menu_arrow.removeClass('ti-minus').addClass('ti-plus');
        }

        setTimeout(function () {
          $('.navigation .navigation-menu-body').getNiceScroll().resize();
        }, 300);
      }

      return false;
    }
  });
  $(document).on('click', '.dropdown-menu', function (e) {
    e.stopPropagation();
  });
  $('#exampleModal').on('show.bs.modal', function (event) {
    var button = $(event.relatedTarget),
        recipient = button.data('whatever'),
        modal = $(this);
    modal.find('.modal-title').text('New message to ' + recipient);
    modal.find('.modal-body input').val(recipient);
  });
  $('[data-toggle="tooltip"]').tooltip({
    container: 'body'
  });
  $('[data-toggle="popover"]').popover();
  $('.carousel').carousel();
  $(document).on('click', '.mobile-header-search-btn', function () {
    $('.header .header-body .header-body-left .header-search-form').addClass('show');
    setTimeout(function () {
      $('.header .header-body .header-body-left .header-search-form .form-control').focus();
    }, 500);
    return false;
  });
  $(document).on('click', '.header-search-close-btn', function () {
    $('.header .header-body .header-body-left .header-search-form').removeClass('show');
    return false;
  });
  $(document).on('click', '.header .header-body .header-body-left .header-search-form', function (e) {
    if (!$(e.target).is($('form *'))) {
      $('.header .header-body .header-body-left .header-search-form').removeClass('show');
    }

    return false;
  });

  if (wind_.width() >= 992) {
    $('.card-scroll').niceScroll();
    $('.dropdown-scroll').niceScroll();
    $('.table-responsive').niceScroll();
    $('.app-block .app-content .app-lists').niceScroll();
    $('.app-block .app-sidebar .app-sidebar-menu').niceScroll();
    $('.chat-block .chat-sidebar .chat-sidebar-content').niceScroll();
    var chat_messages = $('.chat-block .chat-content .messages');

    if (chat_messages.length) {
      chat_messages.niceScroll({
        horizrailenabled: false
      });
      chat_messages.getNiceScroll(0).doScrollTop(chat_messages.get(0).scrollHeight, -1);
    }
  }

  $(document).on('mouseenter', 'body.small-navigation .navigation', function () {
    if (!body_.hasClass('horizontal-navigation') && wind_.width() >= 992) {
      $(this).find('.navigation-menu-body').niceScroll();
    }
  });
  $(document).on('mouseleave', 'body.small-navigation .navigation', function () {
    $('.navigation-menu-body ul li ul').removeAttr('style');
    $(this).find('.navigation-menu-body').getNiceScroll().remove();
  });

  if (!body_.hasClass('small-navigation') && !body_.hasClass('horizontal-navigation') && wind_.width() >= 992) {
    $('.navigation .navigation-menu-body').niceScroll();
  }
})(jQuery);